<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="94px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="name" label="优惠券名称">
                            <el-input v-model="formData.name"></el-input>
                </el-form-item>
                <el-form-item prop="amount" label="金额">
                            <el-input-number type="number" v-model="formData.amount"></el-input-number>
                </el-form-item>
                <el-form-item prop="startDate" label="开始时间">
                            <el-date-picker
                                    v-model="formData.startDate"
                                    type="date"
                                    value-format="yyyy-MM-dd"
                                    placeholder="选择日期">
                            </el-date-picker>
                </el-form-item>
                <el-form-item prop="endDate" label="截止时间">
                            <el-date-picker
                                    v-model="formData.endDate"
                                    type="date"
                                    value-format="yyyy-MM-dd"
                                    placeholder="选择日期">
                            </el-date-picker>
                </el-form-item>

<!--                <el-form-item prop="type" label="优惠券类型">-->
<!--                            <el-select v-model="formData.type" clearable filterable  placeholder="请选择">-->
<!--                                <el-option-->
<!--                                        v-for="item in typeOptions"-->
<!--                                        :key="item.value"-->
<!--                                        :label="item.label"-->
<!--                                        :value="item.value">-->
<!--                                </el-option>-->
<!--                            </el-select>-->
<!--                </el-form-item>-->
                <el-form-item prop="fullAmount" label="满额">
                            <el-input-number type="number" v-model="formData.fullAmount"></el-input-number>
                </el-form-item>
<!--                <el-form-item prop="discount" label="折扣">-->
<!--                            <el-input-number type="number" v-model="formData.discount"></el-input-number>-->
<!--                </el-form-item>-->
<!--                <el-form-item prop="merchantId" label="商家ID">-->
<!--                            <el-input-number type="number" v-model="formData.merchantId"></el-input-number>-->
<!--                </el-form-item>-->
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'CouponEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('coupon/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
                            typeOptions:[{"label":"DISCOUNT","value":"DISCOUNT"},{"label":"CREDIT","value":"CREDIT"},{"label":"REDUCTION","value":"REDUCTION"}],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/coupon/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/coupon/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
